<html>
<head>
<title>OgrePrerequisites.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePrerequisites.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePrerequisites_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*-------------------------------------------------------------------------</span>
<a name="l00002"></a>00002 <span class="comment">This source file is a part of OGRE</span>
<a name="l00003"></a>00003 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE</span>
<a name="l00025"></a>00025 <span class="comment">-------------------------------------------------------------------------*/</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifndef __OgrePrerequisites_H__</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#define __OgrePrerequisites_H__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// Platform-specific stuff</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlatform_8h.html">OgrePlatform.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Needed for OGRE_WCHAR_T_STRINGS below</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// configure memory tracking</span>
<a name="l00037"></a>00037 <span class="preprocessor">#if OGRE_DEBUG_MODE </span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#   if OGRE_MEMORY_TRACKER_DEBUG_MODE</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_MEMORY_TRACKER 1</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_MEMORY_TRACKER 0</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#   if OGRE_MEMORY_TRACKER_RELEASE_MODE</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_MEMORY_TRACKER 1</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00047"></a><a class="code" href="OgrePrerequisites_8h.html#a7087d2ed9eb4e1f820fd300d85df375d">00047</a> <span class="preprocessor"></span><span class="preprocessor">#       define OGRE_MEMORY_TRACKER 0</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="keyword">namespace </span>Ogre {
<a name="l00055"></a>00055     <span class="comment">// Define ogre version</span>
<a name="l00056"></a><a class="code" href="OgrePrerequisites_8h.html#ae5b524dcaad06fe829b6a1952cc6f7cf">00056</a> <span class="preprocessor">    #define OGRE_VERSION_MAJOR 1</span>
<a name="l00057"></a><a class="code" href="OgrePrerequisites_8h.html#a151f60246acece3e651a8f1d0999f85b">00057</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_MINOR 8</span>
<a name="l00058"></a><a class="code" href="OgrePrerequisites_8h.html#a144780d2bcdd852d2ff7a7a450c7856d">00058</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_PATCH 0</span>
<a name="l00059"></a><a class="code" href="OgrePrerequisites_8h.html#abce1e968a0f7309c73a8a2d7a19544e2">00059</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_SUFFIX &quot;&quot;</span>
<a name="l00060"></a><a class="code" href="OgrePrerequisites_8h.html#a4a5177c0cfa26a662edfe3e311935fdf">00060</a> <span class="preprocessor"></span><span class="preprocessor">    #define OGRE_VERSION_NAME &quot;Byatis&quot;</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00062"></a><a class="code" href="OgrePrerequisites_8h.html#a3f631403da0a255c201870bfd068f8c5">00062</a> <span class="preprocessor">    #define OGRE_VERSION    ((OGRE_VERSION_MAJOR &lt;&lt; 16) | (OGRE_VERSION_MINOR &lt;&lt; 8) | OGRE_VERSION_PATCH)</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>
<a name="l00064"></a>00064     <span class="comment">// define the real number values to be used</span>
<a name="l00065"></a>00065     <span class="comment">// default to use &#39;float&#39; unless precompiler option set</span>
<a name="l00066"></a>00066 <span class="preprocessor">    #if OGRE_DOUBLE_PRECISION == 1</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00070"></a>00070         <span class="keyword">typedef</span> <span class="keywordtype">double</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>;
<a name="l00071"></a>00071 <span class="preprocessor">    #else</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>
<a name="l00075"></a><a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">00075</a>         <span class="keyword">typedef</span> <span class="keywordtype">float</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>;
<a name="l00076"></a>00076 <span class="preprocessor">    #endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078 <span class="preprocessor">    #if OGRE_COMPILER == OGRE_COMPILER_GNUC &amp;&amp; OGRE_COMP_VER &gt;= 310 &amp;&amp; !defined(STLPORT)</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span><span class="preprocessor">    #   if OGRE_COMP_VER &gt;= 430</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span><span class="preprocessor">    #       define HashMap ::std::tr1::unordered_map</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span><span class="preprocessor">    #       define HashSet ::std::tr1::unordered_set</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span><span class="preprocessor">    #    else</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span><span class="preprocessor">    #       define HashMap ::__gnu_cxx::hash_map</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span><span class="preprocessor">    #       define HashSet ::__gnu_cxx::hash_set</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span><span class="preprocessor">    #    endif</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span><span class="preprocessor">    #elif OGRE_COMPILER == OGRE_COMPILER_CLANG</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span><span class="preprocessor">    #    if defined(_LIBCPP_VERSION)</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span><span class="preprocessor">    #       define HashMap ::std::unordered_map</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span><span class="preprocessor">    #       define HashSet ::std::unordered_set</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span><span class="preprocessor">    #    else</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span><span class="preprocessor">    #       define HashMap ::std::tr1::unordered_map</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span><span class="preprocessor">    #       define HashSet ::std::tr1::unordered_set</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span><span class="preprocessor">    #    endif</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span><span class="preprocessor">    #else</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span><span class="preprocessor">    #   if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="preprocessor">    #       if OGRE_COMP_VER &gt;= 1600 // VC++ 10.0</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span><span class="preprocessor">    #           define HashMap ::std::tr1::unordered_map</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span><span class="preprocessor">    #           define HashSet ::std::tr1::unordered_set</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span><span class="preprocessor">    #       elif OGRE_COMP_VER &gt; 1300 &amp;&amp; !defined(_STLP_MSVC)</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span><span class="preprocessor">    #           define HashMap ::stdext::hash_map</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="preprocessor">    #           define HashSet ::stdext::hash_set</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span><span class="preprocessor">    #       else</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span><span class="preprocessor">    #           define HashMap ::std::hash_map</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span><span class="preprocessor">    #           define HashSet ::std::hash_set</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span><span class="preprocessor">    #       endif</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span><span class="preprocessor">    #   else</span>
<a name="l00107"></a><a class="code" href="OgrePrerequisites_8h.html#aa3cf5d1d0401f71e90c8684179eb9bf2">00107</a> <span class="preprocessor"></span><span class="preprocessor">    #       define HashMap ::std::hash_map</span>
<a name="l00108"></a><a class="code" href="OgrePrerequisites_8h.html#a082616e233181b887cf317b8d57448c6">00108</a> <span class="preprocessor"></span><span class="preprocessor">    #       define HashSet ::std::hash_set</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span><span class="preprocessor">    #   endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span><span class="preprocessor">    #endif</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>
<a name="l00112"></a><a class="code" href="OgrePrerequisites_8h.html#a5accccc5ab87a1784147e24c55e6bd3e">00112</a> <span class="preprocessor">    #define OGRE_DEFINE_STATIC_LOCAL(type, name, arguments) \</span>
<a name="l00113"></a>00113 <span class="preprocessor">        static type&amp; name = *new type arguments</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00117"></a><a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4">00117</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>;
<a name="l00118"></a><a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">00118</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>;
<a name="l00119"></a><a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">00119</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>;
<a name="l00120"></a><a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">00120</a>     <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="comment">// Useful threading defines</span>
<a name="l00123"></a>00123 <span class="preprocessor">#include &quot;<a class="code" href="OgreThreadDefines_8h.html">Threading/OgreThreadDefines.h</a>&quot;</span>
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="comment">// Pre-declare classes</span>
<a name="l00126"></a>00126 <span class="comment">// Allows use of pointers in header files without including individual .h</span>
<a name="l00127"></a>00127 <span class="comment">// so decreases dependencies between files</span>
<a name="l00128"></a>00128     <span class="keyword">class </span><a class="code" href="classOgre_1_1Angle.html" title="Wrapper class which identifies a value as the currently default angle type, as defined by Math::setAn...">Angle</a>;
<a name="l00129"></a>00129     <span class="keyword">class </span><a class="code" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a>;
<a name="l00130"></a>00130     <span class="keyword">class </span><a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>;
<a name="l00131"></a>00131     <span class="keyword">class </span><a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>;
<a name="l00132"></a>00132     <span class="keyword">class </span><a class="code" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a>;
<a name="l00133"></a>00133     <span class="keyword">class </span><a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>;
<a name="l00134"></a>00134     <span class="keyword">class </span><a class="code" href="classOgre_1_1ArchiveFactory.html" title="Abstract factory class, archive codec plugins can register concrete subclasses of this...">ArchiveFactory</a>;
<a name="l00135"></a>00135     <span class="keyword">class </span><a class="code" href="classOgre_1_1ArchiveManager.html" title="This class manages the available ArchiveFactory plugins.">ArchiveManager</a>;
<a name="l00136"></a>00136     <span class="keyword">class </span><a class="code" href="classOgre_1_1AutoParamDataSource.html" title="This utility class is used to hold the information used to generate the matrices and other informatio...">AutoParamDataSource</a>;
<a name="l00137"></a>00137     <span class="keyword">class </span><a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>;
<a name="l00138"></a>00138     <span class="keyword">class </span><a class="code" href="classOgre_1_1AxisAlignedBoxSceneQuery.html" title="Specialises the SceneQuery class for querying within an axis aligned box.">AxisAlignedBoxSceneQuery</a>;
<a name="l00139"></a>00139     <span class="keyword">class </span><a class="code" href="classOgre_1_1Billboard.html" title="A billboard is a primitive which always faces the camera in every frame.">Billboard</a>;
<a name="l00140"></a>00140     <span class="keyword">class </span><a class="code" href="classOgre_1_1BillboardChain.html" title="Allows the rendering of a chain of connected billboards.">BillboardChain</a>;
<a name="l00141"></a>00141     <span class="keyword">class </span><a class="code" href="classOgre_1_1BillboardSet.html" title="A collection of billboards (faces which are always facing the given direction) with the same (default...">BillboardSet</a>;
<a name="l00142"></a>00142     <span class="keyword">class </span><a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>;
<a name="l00143"></a>00143     <span class="keyword">class </span><a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>;
<a name="l00144"></a>00144     <span class="keyword">class </span><a class="code" href="classOgre_1_1Codec.html" title="Abstract class that defines a &#39;codec&#39;.">Codec</a>;
<a name="l00145"></a>00145     <span class="keyword">class </span><a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>;
<a name="l00146"></a>00146     <span class="keyword">class </span><a class="code" href="classOgre_1_1ConfigDialog.html" title="Defines the behaviour of an automatic renderer configuration dialog.">ConfigDialog</a>;
<a name="l00147"></a>00147     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1Controller.html" title="Instances of this class &#39;control&#39; the value of another object in the system.">Controller</a>;
<a name="l00148"></a>00148     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a>;
<a name="l00149"></a>00149     <span class="keyword">class </span><a class="code" href="classOgre_1_1ControllerManager.html" title="Class for managing Controller instances.">ControllerManager</a>;
<a name="l00150"></a>00150     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>;
<a name="l00151"></a>00151     <span class="keyword">class </span><a class="code" href="classOgre_1_1DefaultWorkQueue.html" title="Implementation of a general purpose request / response style background work queue.">DefaultWorkQueue</a>;
<a name="l00152"></a>00152     <span class="keyword">class </span><a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>;
<a name="l00153"></a>00153     <span class="keyword">class </span><a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>;
<a name="l00154"></a>00154     <span class="keyword">class </span><a class="code" href="classOgre_1_1DynLib.html" title="Resource holding data about a dynamic library.">DynLib</a>;
<a name="l00155"></a>00155     <span class="keyword">class </span><a class="code" href="classOgre_1_1DynLibManager.html" title="Manager for Dynamic-loading Libraries.">DynLibManager</a>;
<a name="l00156"></a>00156     <span class="keyword">class </span><a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of a given set of vert...">EdgeData</a>;
<a name="l00157"></a>00157     <span class="keyword">class </span><a class="code" href="classOgre_1_1EdgeListBuilder.html" title="General utility class for building edge lists for geometry.">EdgeListBuilder</a>;
<a name="l00158"></a>00158     <span class="keyword">class </span><a class="code" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh.">Entity</a>;
<a name="l00159"></a>00159     <span class="keyword">class </span><a class="code" href="classOgre_1_1ErrorDialog.html" title="Class for displaying the error dialog if Ogre fails badly.">ErrorDialog</a>;
<a name="l00160"></a>00160     <span class="keyword">class </span><a class="code" href="classOgre_1_1ExternalTextureSourceManager.html" title="Singleton Class which handles the registering and control of texture plugins.">ExternalTextureSourceManager</a>;
<a name="l00161"></a>00161     <span class="keyword">class </span>Factory;
<a name="l00162"></a>00162     <span class="keyword">class </span><a class="code" href="classOgre_1_1Font.html" title="Class representing a font in the system.">Font</a>;
<a name="l00163"></a>00163     <span class="keyword">class </span><a class="code" href="classOgre_1_1FontPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to FontPtr.">FontPtr</a>;
<a name="l00164"></a>00164     <span class="keyword">class </span><a class="code" href="classOgre_1_1FontManager.html" title="Manages Font resources, parsing .fontdef files and generally organising them.">FontManager</a>;
<a name="l00165"></a>00165     <span class="keyword">struct </span><a class="code" href="structOgre_1_1FrameEvent.html" title="Struct containing information about a frame event.">FrameEvent</a>;
<a name="l00166"></a>00166     <span class="keyword">class </span><a class="code" href="classOgre_1_1FrameListener.html" title="A interface class defining a listener which can be used to receive notifications of frame events...">FrameListener</a>;
<a name="l00167"></a>00167     <span class="keyword">class </span><a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>;
<a name="l00168"></a>00168     <span class="keyword">class </span><a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>;
<a name="l00169"></a>00169     <span class="keyword">class </span><a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>;
<a name="l00170"></a>00170     <span class="keyword">class </span><a class="code" href="classOgre_1_1GpuProgramManager.html">GpuProgramManager</a>;
<a name="l00171"></a>00171     <span class="keyword">class </span><a class="code" href="classOgre_1_1GpuProgramUsage.html" title="This class makes the usage of a vertex and fragment programs (low-level or high-level), with a given set of parameters, explicit.">GpuProgramUsage</a>;
<a name="l00172"></a>00172     <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>;
<a name="l00173"></a>00173     <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a>;
<a name="l00174"></a>00174     <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>;
<a name="l00175"></a>00175     <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>;
<a name="l00176"></a>00176     <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a>;
<a name="l00177"></a>00177     <span class="keyword">class </span><a class="code" href="classOgre_1_1HighLevelGpuProgram.html" title="Abstract base class representing a high-level program (a vertex or fragment program).">HighLevelGpuProgram</a>;
<a name="l00178"></a>00178     <span class="keyword">class </span><a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>;
<a name="l00179"></a>00179     <span class="keyword">class </span><a class="code" href="classOgre_1_1HighLevelGpuProgramManager.html" title="This ResourceManager manages high-level vertex and fragment programs.">HighLevelGpuProgramManager</a>;
<a name="l00180"></a>00180     <span class="keyword">class </span><a class="code" href="classOgre_1_1HighLevelGpuProgramFactory.html" title="Interface definition for factories of HighLevelGpuProgram.">HighLevelGpuProgramFactory</a>;
<a name="l00181"></a>00181     <span class="keyword">class </span><a class="code" href="classOgre_1_1IndexData.html" title="Summary class collecting together index data source information.">IndexData</a>;
<a name="l00182"></a>00182     <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatch.html" title="InstanceBatch forms part of the new Instancing system This is an abstract class that must be derived ...">InstanceBatch</a>;
<a name="l00183"></a>00183     <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatchHW.html" title="This is technique requires true instancing hardware support.">InstanceBatchHW</a>;
<a name="l00184"></a>00184     <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatchHW__VTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) and hardware instan...">InstanceBatchHW_VTF</a>;
<a name="l00185"></a>00185     <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatchShader.html" title="This is the same technique the old &quot;InstancedGeometry&quot; implementation used (with improvements).">InstanceBatchShader</a>;
<a name="l00186"></a>00186     <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceBatchVTF.html">InstanceBatchVTF</a>;
<a name="l00187"></a>00187     <span class="keyword">class </span><a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a>;
<a name="l00188"></a>00188     <span class="keyword">class </span><a class="code" href="classOgre_1_1InstancedEntity.html">InstancedEntity</a>;
<a name="l00189"></a>00189     <span class="keyword">class </span><a class="code" href="classOgre_1_1IntersectionSceneQuery.html" title="Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another...">IntersectionSceneQuery</a>;
<a name="l00190"></a>00190     <span class="keyword">class </span><a class="code" href="classOgre_1_1IntersectionSceneQueryListener.html" title="Alternative listener class for dealing with IntersectionSceneQuery.">IntersectionSceneQueryListener</a>;
<a name="l00191"></a>00191     <span class="keyword">class </span><a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>;
<a name="l00192"></a>00192     <span class="keyword">class </span><a class="code" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a>;
<a name="l00193"></a>00193     <span class="keyword">class </span><a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>;
<a name="l00194"></a>00194     <span class="keyword">class </span><a class="code" href="classOgre_1_1Log.html">Log</a>;
<a name="l00195"></a>00195     <span class="keyword">class </span><a class="code" href="classOgre_1_1LogManager.html" title="The log manager handles the creation and retrieval of logs for the application.">LogManager</a>;
<a name="l00196"></a>00196     <span class="keyword">class </span><a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a>;
<a name="l00197"></a>00197     <span class="keyword">class </span><a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>;
<a name="l00198"></a>00198     <span class="keyword">class </span><a class="code" href="classOgre_1_1ManualObject.html" title="Class providing a much simplified interface to generating manual objects with custom geometry...">ManualObject</a>;
<a name="l00199"></a>00199     <span class="keyword">class </span><a class="code" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a>;
<a name="l00200"></a>00200     <span class="keyword">class </span><a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>;
<a name="l00201"></a>00201     <span class="keyword">class </span><a class="code" href="classOgre_1_1MaterialManager.html" title="Class for managing Material settings for Ogre.">MaterialManager</a>;
<a name="l00202"></a>00202     <span class="keyword">class </span><a class="code" href="classOgre_1_1Math.html" title="Class to provide access to common mathematical functions.">Math</a>;
<a name="l00203"></a>00203     <span class="keyword">class </span><a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>;
<a name="l00204"></a>00204     <span class="keyword">class </span><a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>;
<a name="l00205"></a>00205     <span class="keyword">class </span>MemoryManager;
<a name="l00206"></a>00206     <span class="keyword">class </span><a class="code" href="classOgre_1_1Mesh.html">Mesh</a>;
<a name="l00207"></a>00207     <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a>;
<a name="l00208"></a>00208     <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializer.html" title="Class for serialising mesh data to/from an OGRE .mesh file.">MeshSerializer</a>;
<a name="l00209"></a>00209     <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerImpl.html" title="Internal implementation of Mesh reading / writing for the latest version of the .mesh format...">MeshSerializerImpl</a>;
<a name="l00210"></a>00210     <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshManager.html" title="Handles the management of mesh resources.">MeshManager</a>;
<a name="l00211"></a>00211     <span class="keyword">class </span><a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>;
<a name="l00212"></a>00212     <span class="keyword">class </span><a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a>;
<a name="l00213"></a>00213     <span class="keyword">class </span><a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>;
<a name="l00214"></a>00214     <span class="keyword">class </span><a class="code" href="classOgre_1_1NodeAnimationTrack.html" title="Specialised AnimationTrack for dealing with node transforms.">NodeAnimationTrack</a>;
<a name="l00215"></a>00215     <span class="keyword">class </span>NodeKeyFrame;
<a name="l00216"></a>00216     <span class="keyword">class </span><a class="code" href="classOgre_1_1NumericAnimationTrack.html" title="Specialised AnimationTrack for dealing with generic animable values.">NumericAnimationTrack</a>;
<a name="l00217"></a>00217     <span class="keyword">class </span><a class="code" href="classOgre_1_1NumericKeyFrame.html" title="Specialised KeyFrame which stores any numeric value.">NumericKeyFrame</a>;
<a name="l00218"></a>00218     <span class="keyword">class </span><a class="code" href="classOgre_1_1Overlay.html" title="Represents a layer which is rendered on top of the &#39;normal&#39; scene contents.">Overlay</a>;
<a name="l00219"></a>00219     <span class="keyword">class </span><a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>;
<a name="l00220"></a>00220     <span class="keyword">class </span><a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>;
<a name="l00221"></a>00221     <span class="keyword">class </span><a class="code" href="classOgre_1_1OverlayElementFactory.html" title="Defines the interface which all components wishing to supply OverlayElement subclasses must implement...">OverlayElementFactory</a>;
<a name="l00222"></a>00222     <span class="keyword">class </span><a class="code" href="classOgre_1_1OverlayManager.html" title="Manages Overlay objects, parsing them from .overlay files and storing a lookup library of them...">OverlayManager</a>;
<a name="l00223"></a>00223     <span class="keyword">class </span><a class="code" href="classOgre_1_1Particle.html" title="Class representing a single particle instance.">Particle</a>;
<a name="l00224"></a>00224     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleAffector.html" title="Abstract class defining the interface to be implemented by particle affectors.">ParticleAffector</a>;
<a name="l00225"></a>00225     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleAffectorFactory.html" title="Abstract class defining the interface to be implemented by creators of ParticleAffector subclasses...">ParticleAffectorFactory</a>;
<a name="l00226"></a>00226     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleEmitter.html" title="Abstract class defining the interface to be implemented by particle emitters.">ParticleEmitter</a>;
<a name="l00227"></a>00227     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleEmitterFactory.html" title="Abstract class defining the interface to be implemented by creators of ParticleEmitter subclasses...">ParticleEmitterFactory</a>;
<a name="l00228"></a>00228     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleSystem.html" title="Class defining particle system based special effects.">ParticleSystem</a>;
<a name="l00229"></a>00229     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleSystemManager.html" title="Manages particle systems, particle system scripts (templates) and the available emitter &amp; affector fa...">ParticleSystemManager</a>;
<a name="l00230"></a>00230     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleSystemRenderer.html" title="Abstract class defining the interface required to be implemented by classes which provide rendering c...">ParticleSystemRenderer</a>;
<a name="l00231"></a>00231     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleSystemRendererFactory.html" title="Abstract class definition of a factory object for ParticleSystemRenderer.">ParticleSystemRendererFactory</a>;
<a name="l00232"></a>00232     <span class="keyword">class </span><a class="code" href="classOgre_1_1ParticleVisualData.html" title="Abstract class containing any additional data required to be associated with a particle to perform th...">ParticleVisualData</a>;
<a name="l00233"></a>00233     <span class="keyword">class </span><a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), i.e.">Pass</a>;
<a name="l00234"></a>00234     <span class="keyword">class </span><a class="code" href="classOgre_1_1PatchMesh.html" title="Patch specialisation of Mesh.">PatchMesh</a>;
<a name="l00235"></a>00235     <span class="keyword">class </span><a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a>;
<a name="l00236"></a>00236     <span class="keyword">class </span><a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>;
<a name="l00237"></a>00237     <span class="keyword">class </span><a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>;
<a name="l00238"></a>00238     <span class="keyword">class </span><a class="code" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a>;
<a name="l00239"></a>00239     <span class="keyword">class </span><a class="code" href="classOgre_1_1Pose.html" title="A pose is a linked set of vertex offsets applying to one set of vertex data.">Pose</a>;
<a name="l00240"></a>00240     <span class="keyword">class </span><a class="code" href="classOgre_1_1ProgressiveMesh.html" title="This class reduces the complexity of the geometry it is given.">ProgressiveMesh</a>;
<a name="l00241"></a>00241     <span class="keyword">class </span><a class="code" href="classOgre_1_1Profile.html" title="An individual profile that will be processed by the Profiler.">Profile</a>;
<a name="l00242"></a>00242     <span class="keyword">class </span><a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>;
<a name="l00243"></a>00243     <span class="keyword">class </span><a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>;
<a name="l00244"></a>00244     <span class="keyword">class </span><a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>;
<a name="l00245"></a>00245     <span class="keyword">class </span><a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, i.e.">Ray</a>;
<a name="l00246"></a>00246     <span class="keyword">class </span><a class="code" href="classOgre_1_1RaySceneQuery.html" title="Specialises the SceneQuery class for querying along a ray.">RaySceneQuery</a>;
<a name="l00247"></a>00247     <span class="keyword">class </span><a class="code" href="classOgre_1_1RaySceneQueryListener.html" title="Alternative listener class for dealing with RaySceneQuery.">RaySceneQueryListener</a>;
<a name="l00248"></a>00248     <span class="keyword">class </span><a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>;
<a name="l00249"></a>00249     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderPriorityGroup.html" title="Collection of renderables by priority.">RenderPriorityGroup</a>;
<a name="l00250"></a>00250     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>;
<a name="l00251"></a>00251     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>;
<a name="l00252"></a>00252     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueueInvocation.html" title="Class representing the invocation of queue groups in a RenderQueue.">RenderQueueInvocation</a>;
<a name="l00253"></a>00253     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>;
<a name="l00254"></a>00254     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueueListener.html" title="Abstract interface which classes must implement if they wish to receive events from the render queue...">RenderQueueListener</a>;
<a name="l00255"></a>00255     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderObjectListener.html" title="Abstract interface which classes must implement if they wish to receive events from the scene manager...">RenderObjectListener</a>;
<a name="l00256"></a>00256     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>;
<a name="l00257"></a>00257     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>;
<a name="l00258"></a>00258     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderSystemCapabilitiesManager.html" title="Class for managing RenderSystemCapabilities database for Ogre.">RenderSystemCapabilitiesManager</a>;
<a name="l00259"></a>00259     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderSystemCapabilitiesSerializer.html" title="Class for serializing RenderSystemCapabilities to / from a .rendercaps script.">RenderSystemCapabilitiesSerializer</a>;
<a name="l00260"></a>00260     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>;
<a name="l00261"></a>00261     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderTargetListener.html" title="A interface class defining a listener which can be used to receive notifications of RenderTarget even...">RenderTargetListener</a>;
<a name="l00262"></a>00262     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>;
<a name="l00263"></a>00263     <span class="keyword">class </span><a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a>;
<a name="l00264"></a>00264     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>;
<a name="l00265"></a>00265     <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>;
<a name="l00266"></a>00266     <span class="keyword">class </span><a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>;
<a name="l00267"></a>00267     <span class="keyword">class </span><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>;
<a name="l00268"></a>00268     <span class="keyword">class </span><a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a>;
<a name="l00269"></a>00269     <span class="keyword">class </span><a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>;
<a name="l00270"></a>00270     <span class="keyword">class </span><a class="code" href="classOgre_1_1RibbonTrail.html" title="Subclass of BillboardChain which automatically leaves a trail behind one or more Node instances...">RibbonTrail</a>;
<a name="l00271"></a>00271     <span class="keyword">class </span><a class="code" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a>;
<a name="l00272"></a>00272     <span class="keyword">class </span><a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>;
<a name="l00273"></a>00273     <span class="keyword">class </span><a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>;
<a name="l00274"></a>00274     <span class="keyword">class </span><a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>;
<a name="l00275"></a>00275     <span class="keyword">class </span><a class="code" href="classOgre_1_1SceneQuery.html" title="A class for performing queries on a scene.">SceneQuery</a>;
<a name="l00276"></a>00276     <span class="keyword">class </span><a class="code" href="classOgre_1_1SceneQueryListener.html" title="This optional class allows you to receive per-result callbacks from SceneQuery executions instead of ...">SceneQueryListener</a>;
<a name="l00277"></a>00277     <span class="keyword">class </span><a class="code" href="classOgre_1_1ScriptCompiler.html" title="This is the main class for the compiler.">ScriptCompiler</a>;
<a name="l00278"></a>00278     <span class="keyword">class </span><a class="code" href="classOgre_1_1ScriptCompilerManager.html" title="Manages threaded compilation of scripts.">ScriptCompilerManager</a>;
<a name="l00279"></a>00279     <span class="keyword">class </span><a class="code" href="classOgre_1_1ScriptLoader.html" title="Abstract class defining the interface used by classes which wish to perform script loading to define ...">ScriptLoader</a>;
<a name="l00280"></a>00280     <span class="keyword">class </span><a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>;
<a name="l00281"></a>00281     <span class="keyword">class </span><a class="code" href="classOgre_1_1ShadowCaster.html" title="This class defines the interface that must be implemented by shadow casters.">ShadowCaster</a>;
<a name="l00282"></a>00282     <span class="keyword">class </span><a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>;
<a name="l00283"></a>00283     <span class="keyword">class </span><a class="code" href="classOgre_1_1ShadowTextureManager.html" title="Class to manage the available shadow textures which may be shared between many SceneManager instances...">ShadowTextureManager</a>;
<a name="l00284"></a>00284     <span class="keyword">class </span><a class="code" href="classOgre_1_1SimpleRenderable.html" title="Simple implementation of MovableObject and Renderable for single-part custom objects.">SimpleRenderable</a>;
<a name="l00285"></a>00285     <span class="keyword">class </span><a class="code" href="classOgre_1_1SimpleSpline.html" title="A very simple spline class which implements the Catmull-Rom class of splines.">SimpleSpline</a>;
<a name="l00286"></a>00286     <span class="keyword">class </span><a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>;
<a name="l00287"></a>00287     <span class="keyword">class </span><a class="code" href="classOgre_1_1SkeletonPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to SkeletonPtr.">SkeletonPtr</a>;
<a name="l00288"></a>00288     <span class="keyword">class </span><a class="code" href="classOgre_1_1SkeletonInstance.html" title="A SkeletonInstance is a single instance of a Skeleton used by a world object.">SkeletonInstance</a>;
<a name="l00289"></a>00289     <span class="keyword">class </span><a class="code" href="classOgre_1_1SkeletonManager.html" title="Handles the management of skeleton resources.">SkeletonManager</a>;
<a name="l00290"></a>00290     <span class="keyword">class </span><a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>;
<a name="l00291"></a>00291     <span class="keyword">class </span><a class="code" href="classOgre_1_1SphereSceneQuery.html" title="Specialises the SceneQuery class for querying within a sphere.">SphereSceneQuery</a>;
<a name="l00292"></a>00292     <span class="keyword">class </span><a class="code" href="classOgre_1_1StaticGeometry.html" title="Pre-transforms and batches up meshes for efficient use as static geometry in a scene.">StaticGeometry</a>;
<a name="l00293"></a>00293     <span class="keyword">class </span><a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>;
<a name="l00294"></a>00294     <span class="keyword">class </span><a class="code" href="classOgre_1_1StringConverter.html" title="Class for converting the core Ogre data types to/from Strings.">StringConverter</a>;
<a name="l00295"></a>00295     <span class="keyword">class </span><a class="code" href="classOgre_1_1StringInterface.html" title="Class defining the common interface which classes can use to present a reflection-style, self-defining parameter set to callers.">StringInterface</a>;
<a name="l00296"></a>00296     <span class="keyword">class </span><a class="code" href="classOgre_1_1SubEntity.html" title="Utility class which defines the sub-parts of an Entity.">SubEntity</a>;
<a name="l00297"></a>00297     <span class="keyword">class </span><a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>;
<a name="l00298"></a>00298     <span class="keyword">class </span><a class="code" href="classOgre_1_1TagPoint.html" title="A tagged point on a skeleton, which can be used to attach entities to on specific other entities...">TagPoint</a>;
<a name="l00299"></a>00299     <span class="keyword">class </span><a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>;
<a name="l00300"></a>00300     <span class="keyword">class </span><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html" title="Structure for recording the use of temporary blend buffers.">TempBlendedBufferInfo</a>;
<a name="l00301"></a>00301     <span class="keyword">class </span><a class="code" href="classOgre_1_1ExternalTextureSource.html" title="IMPORTANT: **Plugins must override default dictionary name!** Base class that texture plugins derive ...">ExternalTextureSource</a>;
<a name="l00302"></a>00302     <span class="keyword">class </span><a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>;
<a name="l00303"></a>00303     <span class="keyword">class </span><a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>;
<a name="l00304"></a>00304     <span class="keyword">class </span><a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>;
<a name="l00305"></a>00305     <span class="keyword">class </span><a class="code" href="classOgre_1_1TextureManager.html" title="Class for loading &amp; managing textures.">TextureManager</a>;
<a name="l00306"></a>00306     <span class="keyword">class </span><a class="code" href="classOgre_1_1TransformKeyFrame.html" title="Specialised KeyFrame which stores a full transform.">TransformKeyFrame</a>;
<a name="l00307"></a>00307     <span class="keyword">class </span><a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>;
<a name="l00308"></a>00308     <span class="keyword">class </span><a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>;
<a name="l00309"></a>00309     <span class="keyword">class </span><a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>;
<a name="l00310"></a>00310     <span class="keyword">class </span><a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>;
<a name="l00311"></a>00311     <span class="keyword">class </span><a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogeneous vector.">Vector4</a>;
<a name="l00312"></a>00312     <span class="keyword">class </span><a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>;
<a name="l00313"></a>00313     <span class="keyword">class </span><a class="code" href="classOgre_1_1VertexAnimationTrack.html" title="Specialised AnimationTrack for dealing with changing vertex position information.">VertexAnimationTrack</a>;
<a name="l00314"></a>00314     <span class="keyword">class </span><a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>;
<a name="l00315"></a>00315     <span class="keyword">class </span><a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>;
<a name="l00316"></a>00316     <span class="keyword">class </span><a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>;
<a name="l00317"></a>00317     <span class="keyword">class </span><a class="code" href="classOgre_1_1VertexMorphKeyFrame.html" title="Specialised KeyFrame which stores absolute vertex positions for a complete buffer, designed to be interpolated with other keys in the same track.">VertexMorphKeyFrame</a>;
<a name="l00318"></a>00318     <span class="keyword">class </span><a class="code" href="classOgre_1_1WireBoundingBox.html" title="Allows the rendering of a wireframe bounding box.">WireBoundingBox</a>;
<a name="l00319"></a>00319     <span class="keyword">class </span><a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>;
<a name="l00320"></a>00320     <span class="keyword">class </span><a class="code" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a>;
<a name="l00321"></a>00321     <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre.">CompositorManager</a>;
<a name="l00322"></a>00322     <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a>;
<a name="l00323"></a>00323     <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>;
<a name="l00324"></a>00324     <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositorLogic.html" title="Interface for compositor logics, which can be automatically binded to compositors, allowing per-compositor logic (such as attaching a relevant listener) to happen automatically.">CompositorLogic</a>;
<a name="l00325"></a>00325     <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a>;
<a name="l00326"></a>00326     <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositionPass.html" title="Object representing one pass or operation in a composition sequence.">CompositionPass</a>;
<a name="l00327"></a>00327     <span class="keyword">class </span><a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a>;
<a name="l00328"></a>00328     <span class="keyword">class </span><a class="code" href="classOgre_1_1CustomCompositionPass.html" title="Interface for custom composition passes, allowing custom operations (in addition to the quad...">CustomCompositionPass</a>;
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 <span class="comment">/* Include all the standard header *after* all the configuration</span>
<a name="l00332"></a>00332 <span class="comment">settings have been made.</span>
<a name="l00333"></a>00333 <span class="comment">*/</span>
<a name="l00334"></a>00334 <span class="preprocessor">#include &quot;<a class="code" href="OgreStdHeaders_8h.html">OgreStdHeaders.h</a>&quot;</span>
<a name="l00335"></a>00335 <span class="preprocessor">#include &quot;<a class="code" href="OgreMemoryAllocatorConfig_8h.html" title="This file configures Ogre&#39;s memory allocators.">OgreMemoryAllocatorConfig.h</a>&quot;</span>
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="keyword">namespace </span>Ogre
<a name="l00339"></a>00339 {
<a name="l00340"></a>00340 <span class="preprocessor">#if OGRE_STRING_USE_CUSTOM_MEMORY_ALLOCATOR</span>
<a name="l00341"></a>00341 <span class="preprocessor"></span><span class="preprocessor">    #if OGRE_WCHAR_T_STRINGS</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::basic_string&lt;wchar_t, std::char_traits&lt;wchar_t&gt;, STLAllocator&lt;wchar_t,GeneralAllocPolicy &gt; &gt;   <a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">_StringBase</a>;
<a name="l00343"></a>00343 <span class="preprocessor">    #else</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::basic_string&lt;char, std::char_traits&lt;char&gt;, STLAllocator&lt;char,GeneralAllocPolicy &gt; &gt;    <a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">_StringBase</a>;
<a name="l00345"></a>00345 <span class="preprocessor">    #endif</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span>
<a name="l00347"></a>00347 <span class="preprocessor">    #if OGRE_WCHAR_T_STRINGS</span>
<a name="l00348"></a>00348 <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::basic_stringstream&lt;wchar_t,std::char_traits&lt;wchar_t&gt;,STLAllocator&lt;wchar_t,GeneralAllocPolicy &gt;&gt; <a class="code" href="namespaceOgre.html#a9e58d974b559e9184139357d0cb30ba5">_StringStreamBase</a>;
<a name="l00349"></a>00349 <span class="preprocessor">    #else</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::basic_stringstream&lt;char,std::char_traits&lt;char&gt;,STLAllocator&lt;char,GeneralAllocPolicy &gt; &gt; <a class="code" href="namespaceOgre.html#a9e58d974b559e9184139357d0cb30ba5">_StringStreamBase</a>;
<a name="l00351"></a>00351 <span class="preprocessor">    #endif</span>
<a name="l00352"></a>00352 <span class="preprocessor"></span>
<a name="l00353"></a>00353 <span class="preprocessor">    #define StdStringT(T) std::basic_string&lt;T, std::char_traits&lt;T&gt;, std::allocator&lt;T&gt; &gt; </span>
<a name="l00354"></a>00354 <span class="preprocessor"></span><span class="preprocessor">    #define CustomMemoryStringT(T) std::basic_string&lt;T, std::char_traits&lt;T&gt;, STLAllocator&lt;T,GeneralAllocPolicy&gt; &gt;   </span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>
<a name="l00356"></a>00356     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00357"></a>00357     <span class="keywordtype">bool</span> <a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">operator &lt;</a>(<span class="keyword">const</span> CustomMemoryStringT(T)&amp; l,<span class="keyword">const</span> StdStringT(T)&amp; o)
<a name="l00358"></a>00358     {
<a name="l00359"></a>00359         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&lt;0;
<a name="l00360"></a>00360     }
<a name="l00361"></a>00361     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00362"></a>00362     <span class="keywordtype">bool</span> <a class="code" href="group__General.html#gae1dbf4506ab2500da5ec4ef0b58cb2e1">operator &lt;</a>(<span class="keyword">const</span> StdStringT(T)&amp; l,<span class="keyword">const</span> CustomMemoryStringT(T)&amp; o)
<a name="l00363"></a>00363     {
<a name="l00364"></a>00364         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&lt;0;
<a name="l00365"></a>00365     }
<a name="l00366"></a>00366     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00367"></a>00367     <span class="keywordtype">bool</span> operator &lt;=(<span class="keyword">const</span> CustomMemoryStringT(T)&amp; l,<span class="keyword">const</span> StdStringT(T)&amp; o)
<a name="l00368"></a>00368     {
<a name="l00369"></a>00369         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&lt;=0;
<a name="l00370"></a>00370     }
<a name="l00371"></a>00371     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00372"></a>00372     <span class="keywordtype">bool</span> operator &lt;=(<span class="keyword">const</span> StdStringT(T)&amp; l,<span class="keyword">const</span> CustomMemoryStringT(T)&amp; o)
<a name="l00373"></a>00373     {
<a name="l00374"></a>00374         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&lt;=0;
<a name="l00375"></a>00375     }
<a name="l00376"></a>00376     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00377"></a>00377     <span class="keywordtype">bool</span> operator &gt;(<span class="keyword">const</span> CustomMemoryStringT(T)&amp; l,<span class="keyword">const</span> StdStringT(T)&amp; o)
<a name="l00378"></a>00378     {
<a name="l00379"></a>00379         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&gt;0;
<a name="l00380"></a>00380     }
<a name="l00381"></a>00381     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00382"></a>00382     <span class="keywordtype">bool</span> operator &gt;(<span class="keyword">const</span> StdStringT(T)&amp; l,<span class="keyword">const</span> CustomMemoryStringT(T)&amp; o)
<a name="l00383"></a>00383     {
<a name="l00384"></a>00384         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&gt;0;
<a name="l00385"></a>00385     }
<a name="l00386"></a>00386     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00387"></a>00387     <span class="keywordtype">bool</span> operator &gt;=(<span class="keyword">const</span> CustomMemoryStringT(T)&amp; l,<span class="keyword">const</span> StdStringT(T)&amp; o)
<a name="l00388"></a>00388     {
<a name="l00389"></a>00389         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&gt;=0;
<a name="l00390"></a>00390     }
<a name="l00391"></a>00391     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00392"></a>00392     <span class="keywordtype">bool</span> operator &gt;=(<span class="keyword">const</span> StdStringT(T)&amp; l,<span class="keyword">const</span> CustomMemoryStringT(T)&amp; o)
<a name="l00393"></a>00393     {
<a name="l00394"></a>00394         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())&gt;=0;
<a name="l00395"></a>00395     }
<a name="l00396"></a>00396 
<a name="l00397"></a>00397     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00398"></a>00398     <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator ==</a>(<span class="keyword">const</span> CustomMemoryStringT(T)&amp; l,<span class="keyword">const</span> StdStringT(T)&amp; o)
<a name="l00399"></a>00399     {
<a name="l00400"></a>00400         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())==0;
<a name="l00401"></a>00401     }
<a name="l00402"></a>00402     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00403"></a>00403     <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator ==</a>(<span class="keyword">const</span> StdStringT(T)&amp; l,<span class="keyword">const</span> CustomMemoryStringT(T)&amp; o)
<a name="l00404"></a>00404     {
<a name="l00405"></a>00405         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())==0;
<a name="l00406"></a>00406     }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00409"></a>00409     <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator !=</a>(<span class="keyword">const</span> CustomMemoryStringT(T)&amp; l,<span class="keyword">const</span> StdStringT(T)&amp; o)
<a name="l00410"></a>00410     {
<a name="l00411"></a>00411         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())!=0;
<a name="l00412"></a>00412     }
<a name="l00413"></a>00413     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00414"></a>00414     <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator !=</a>(<span class="keyword">const</span> StdStringT(T)&amp; l,<span class="keyword">const</span> CustomMemoryStringT(T)&amp; o)
<a name="l00415"></a>00415     {
<a name="l00416"></a>00416         <span class="keywordflow">return</span> l.compare(0,l.length(),o.c_str(),o.length())!=0;
<a name="l00417"></a>00417     }
<a name="l00418"></a>00418 
<a name="l00419"></a>00419     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00420"></a>00420     CustomMemoryStringT(T) operator +=(const CustomMemoryStringT(T)&amp; l,const StdStringT(T)&amp; o)
<a name="l00421"></a>00421     {
<a name="l00422"></a>00422         <span class="keywordflow">return</span> CustomMemoryStringT(T)(l)+=o.c_str();
<a name="l00423"></a>00423     }
<a name="l00424"></a>00424     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00425"></a>00425     CustomMemoryStringT(T) operator +=(const StdStringT(T)&amp; l,const CustomMemoryStringT(T)&amp; o)
<a name="l00426"></a>00426     {
<a name="l00427"></a>00427         <span class="keywordflow">return</span> CustomMemoryStringT(T)(l.c_str())+=o.c_str();
<a name="l00428"></a>00428     }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00431"></a>00431     CustomMemoryStringT(T) operator +(const CustomMemoryStringT(T)&amp; l,const StdStringT(T)&amp; o)
<a name="l00432"></a>00432     {
<a name="l00433"></a>00433         <span class="keywordflow">return</span> CustomMemoryStringT(T)(l)+=o.c_str();
<a name="l00434"></a>00434     }
<a name="l00435"></a>00435 
<a name="l00436"></a>00436     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00437"></a>00437     CustomMemoryStringT(T) operator +(const StdStringT(T)&amp; l,const CustomMemoryStringT(T)&amp; o)
<a name="l00438"></a>00438     {
<a name="l00439"></a>00439         <span class="keywordflow">return</span> CustomMemoryStringT(T)(l.c_str())+=o.c_str();
<a name="l00440"></a>00440     }
<a name="l00441"></a>00441 
<a name="l00442"></a>00442     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00443"></a>00443     CustomMemoryStringT(T) operator +(const T* l,const CustomMemoryStringT(T)&amp; o)
<a name="l00444"></a>00444     {
<a name="l00445"></a>00445         <span class="keywordflow">return</span> CustomMemoryStringT(T)(l)+=o;
<a name="l00446"></a>00446     }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 <span class="preprocessor">    #undef StdStringT</span>
<a name="l00449"></a>00449 <span class="preprocessor"></span><span class="preprocessor">    #undef CustomMemoryStringT</span>
<a name="l00450"></a>00450 <span class="preprocessor"></span>
<a name="l00451"></a>00451 <span class="preprocessor">#else</span>
<a name="l00452"></a>00452 <span class="preprocessor"></span><span class="preprocessor">    #if OGRE_WCHAR_T_STRINGS</span>
<a name="l00453"></a>00453 <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::wstring <a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">_StringBase</a>;
<a name="l00454"></a>00454 <span class="preprocessor">    #else</span>
<a name="l00455"></a><a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">00455</a> <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::string <a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">_StringBase</a>;
<a name="l00456"></a>00456 <span class="preprocessor">    #endif</span>
<a name="l00457"></a>00457 <span class="preprocessor"></span>
<a name="l00458"></a>00458 <span class="preprocessor">    #if OGRE_WCHAR_T_STRINGS</span>
<a name="l00459"></a>00459 <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::basic_stringstream&lt;wchar_t,std::char_traits&lt;wchar_t&gt;,std::allocator&lt;wchar_t&gt; &gt; <a class="code" href="namespaceOgre.html#a9e58d974b559e9184139357d0cb30ba5">_StringStreamBase</a>;
<a name="l00460"></a>00460 <span class="preprocessor">    #else</span>
<a name="l00461"></a><a class="code" href="namespaceOgre.html#a9e58d974b559e9184139357d0cb30ba5">00461</a> <span class="preprocessor"></span>        <span class="keyword">typedef</span> std::basic_stringstream&lt;char,std::char_traits&lt;char&gt;,std::allocator&lt;char&gt; &gt; <a class="code" href="namespaceOgre.html#a9e58d974b559e9184139357d0cb30ba5">_StringStreamBase</a>;
<a name="l00462"></a>00462 <span class="preprocessor">    #endif</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>
<a name="l00464"></a>00464 <span class="preprocessor">#endif</span>
<a name="l00465"></a>00465 <span class="preprocessor"></span>
<a name="l00466"></a><a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">00466</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">_StringBase</a> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>;
<a name="l00467"></a><a class="code" href="namespaceOgre.html#a9f14407f349c1ec70ddab871a7806590">00467</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#a9e58d974b559e9184139357d0cb30ba5">_StringStreamBase</a> <a class="code" href="namespaceOgre.html#a9f14407f349c1ec70ddab871a7806590">StringStream</a>;
<a name="l00468"></a><a class="code" href="namespaceOgre.html#a64e76a61ffe0fc66797727c518151d35">00468</a>     <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#a9f14407f349c1ec70ddab871a7806590">StringStream</a> <a class="code" href="namespaceOgre.html#a64e76a61ffe0fc66797727c518151d35">stringstream</a>;
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 <span class="comment">//for stl container</span>
<a name="l00473"></a>00473 <span class="keyword">namespace </span>Ogre
<a name="l00474"></a>00474 { 
<a name="l00475"></a>00475     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> A = STLAllocator&lt;T, GeneralAllocPolicy&gt; &gt; 
<a name="l00476"></a><a class="code" href="structOgre_1_1deque.html">00476</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1deque.html">deque</a> 
<a name="l00477"></a>00477     { 
<a name="l00478"></a>00478 <span class="preprocessor">#if OGRE_CONTAINERS_USE_CUSTOM_MEMORY_ALLOCATOR</span>
<a name="l00479"></a><a class="code" href="structOgre_1_1deque.html#a7296ba4fcb7a0674c6d12345155efe02">00479</a> <span class="preprocessor"></span>       <span class="keyword">typedef</span> <span class="keyword">typename</span> std::deque&lt;T, A&gt; <a class="code" href="structOgre_1_1deque.html#a7296ba4fcb7a0674c6d12345155efe02">type</a>;    
<a name="l00480"></a><a class="code" href="structOgre_1_1deque.html#adef10edbb5a79b34333ccc22d485ddcb">00480</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::deque&lt;T, A&gt;::iterator <a class="code" href="structOgre_1_1deque.html#adef10edbb5a79b34333ccc22d485ddcb">iterator</a>;
<a name="l00481"></a><a class="code" href="structOgre_1_1deque.html#a75d8ae7a32cb680b01d37c0bfe293755">00481</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::deque&lt;T, A&gt;::const_iterator <a class="code" href="structOgre_1_1deque.html#a75d8ae7a32cb680b01d37c0bfe293755">const_iterator</a>;
<a name="l00482"></a>00482 <span class="preprocessor">#else</span>
<a name="l00483"></a>00483 <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::deque&lt;T&gt; <a class="code" href="structOgre_1_1deque.html#a7296ba4fcb7a0674c6d12345155efe02">type</a>;
<a name="l00484"></a>00484         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::deque&lt;T&gt;::iterator <a class="code" href="structOgre_1_1deque.html#adef10edbb5a79b34333ccc22d485ddcb">iterator</a>;
<a name="l00485"></a>00485         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::deque&lt;T&gt;::const_iterator <a class="code" href="structOgre_1_1deque.html#a75d8ae7a32cb680b01d37c0bfe293755">const_iterator</a>;
<a name="l00486"></a>00486 <span class="preprocessor">#endif</span>
<a name="l00487"></a>00487 <span class="preprocessor"></span>    }; 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> A = STLAllocator&lt;T, GeneralAllocPolicy&gt; &gt; 
<a name="l00490"></a><a class="code" href="structOgre_1_1vector.html">00490</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1vector.html">vector</a> 
<a name="l00491"></a>00491     { 
<a name="l00492"></a>00492 <span class="preprocessor">#if OGRE_CONTAINERS_USE_CUSTOM_MEMORY_ALLOCATOR</span>
<a name="l00493"></a><a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">00493</a> <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;T, A&gt; <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">type</a>;
<a name="l00494"></a><a class="code" href="structOgre_1_1vector.html#a0d94bfcf99dd03e461a947971c162dcc">00494</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;T, A&gt;::iterator <a class="code" href="structOgre_1_1vector.html#a0d94bfcf99dd03e461a947971c162dcc">iterator</a>;
<a name="l00495"></a><a class="code" href="structOgre_1_1vector.html#acc3b2cd6136b1eaabcd5eca773a6c5f2">00495</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;T, A&gt;::const_iterator <a class="code" href="structOgre_1_1vector.html#acc3b2cd6136b1eaabcd5eca773a6c5f2">const_iterator</a>;
<a name="l00496"></a>00496 <span class="preprocessor">#else</span>
<a name="l00497"></a>00497 <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;T&gt; <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">type</a>;
<a name="l00498"></a>00498         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;T&gt;::iterator <a class="code" href="structOgre_1_1vector.html#a0d94bfcf99dd03e461a947971c162dcc">iterator</a>;
<a name="l00499"></a>00499         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;T&gt;::const_iterator <a class="code" href="structOgre_1_1vector.html#acc3b2cd6136b1eaabcd5eca773a6c5f2">const_iterator</a>;
<a name="l00500"></a>00500 <span class="preprocessor">#endif</span>
<a name="l00501"></a>00501 <span class="preprocessor"></span>    }; 
<a name="l00502"></a>00502 
<a name="l00503"></a>00503     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> A = STLAllocator&lt;T, GeneralAllocPolicy&gt; &gt; 
<a name="l00504"></a><a class="code" href="structOgre_1_1list.html">00504</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1list.html">list</a> 
<a name="l00505"></a>00505     { 
<a name="l00506"></a>00506 <span class="preprocessor">#if OGRE_CONTAINERS_USE_CUSTOM_MEMORY_ALLOCATOR</span>
<a name="l00507"></a><a class="code" href="structOgre_1_1list.html#ac64759673476a6852c0a09e1acec2a8c">00507</a> <span class="preprocessor"></span>       <span class="keyword">typedef</span> <span class="keyword">typename</span> std::list&lt;T, A&gt; <a class="code" href="structOgre_1_1list.html#ac64759673476a6852c0a09e1acec2a8c">type</a>;
<a name="l00508"></a><a class="code" href="structOgre_1_1list.html#a53279ede0055c4e2bfc52708035b80b4">00508</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::list&lt;T, A&gt;::iterator <a class="code" href="structOgre_1_1list.html#a53279ede0055c4e2bfc52708035b80b4">iterator</a>;
<a name="l00509"></a><a class="code" href="structOgre_1_1list.html#af8e09e11654e2a788f0bdde4941ff2fb">00509</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::list&lt;T, A&gt;::const_iterator <a class="code" href="structOgre_1_1list.html#af8e09e11654e2a788f0bdde4941ff2fb">const_iterator</a>;
<a name="l00510"></a>00510 <span class="preprocessor">#else</span>
<a name="l00511"></a>00511 <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::list&lt;T&gt; <a class="code" href="structOgre_1_1list.html#ac64759673476a6852c0a09e1acec2a8c">type</a>;
<a name="l00512"></a>00512         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::list&lt;T&gt;::iterator <a class="code" href="structOgre_1_1list.html#a53279ede0055c4e2bfc52708035b80b4">iterator</a>;
<a name="l00513"></a>00513         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::list&lt;T&gt;::const_iterator <a class="code" href="structOgre_1_1list.html#af8e09e11654e2a788f0bdde4941ff2fb">const_iterator</a>;
<a name="l00514"></a>00514 <span class="preprocessor">#endif</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>    }; 
<a name="l00516"></a>00516 
<a name="l00517"></a>00517     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> P = std::less&lt;T&gt;, <span class="keyword">typename</span> A = STLAllocator&lt;T, GeneralAllocPolicy&gt; &gt; 
<a name="l00518"></a><a class="code" href="structOgre_1_1set.html">00518</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1set.html">set</a> 
<a name="l00519"></a>00519     { 
<a name="l00520"></a>00520 <span class="preprocessor">#if OGRE_CONTAINERS_USE_CUSTOM_MEMORY_ALLOCATOR</span>
<a name="l00521"></a><a class="code" href="structOgre_1_1set.html#a7ac5eb4c7cfd2a56392fe863bcb415c0">00521</a> <span class="preprocessor"></span>       <span class="keyword">typedef</span> <span class="keyword">typename</span> std::set&lt;T, P, A&gt; <a class="code" href="structOgre_1_1set.html#a7ac5eb4c7cfd2a56392fe863bcb415c0">type</a>;
<a name="l00522"></a><a class="code" href="structOgre_1_1set.html#a7d2913cc00295c34e16f98fc50d6baae">00522</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::set&lt;T, P, A&gt;::iterator <a class="code" href="structOgre_1_1set.html#a7d2913cc00295c34e16f98fc50d6baae">iterator</a>;
<a name="l00523"></a><a class="code" href="structOgre_1_1set.html#a5f4d266898d985cf5627b8cd6b89108d">00523</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::set&lt;T, P, A&gt;::const_iterator <a class="code" href="structOgre_1_1set.html#a5f4d266898d985cf5627b8cd6b89108d">const_iterator</a>;
<a name="l00524"></a>00524 <span class="preprocessor">#else</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::set&lt;T, P&gt; <a class="code" href="structOgre_1_1set.html#a7ac5eb4c7cfd2a56392fe863bcb415c0">type</a>;
<a name="l00526"></a>00526         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::set&lt;T, P&gt;::iterator <a class="code" href="structOgre_1_1set.html#a7d2913cc00295c34e16f98fc50d6baae">iterator</a>;
<a name="l00527"></a>00527         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::set&lt;T, P&gt;::const_iterator <a class="code" href="structOgre_1_1set.html#a5f4d266898d985cf5627b8cd6b89108d">const_iterator</a>;
<a name="l00528"></a>00528 <span class="preprocessor">#endif</span>
<a name="l00529"></a>00529 <span class="preprocessor"></span>    }; 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> K, <span class="keyword">typename</span> V, <span class="keyword">typename</span> P = std::less&lt;K&gt;, <span class="keyword">typename</span> A = STLAllocator&lt;std::pair&lt;const K, V&gt;, GeneralAllocPolicy&gt; &gt; 
<a name="l00532"></a><a class="code" href="structOgre_1_1map.html">00532</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1map.html">map</a> 
<a name="l00533"></a>00533     { 
<a name="l00534"></a>00534 <span class="preprocessor">#if OGRE_CONTAINERS_USE_CUSTOM_MEMORY_ALLOCATOR</span>
<a name="l00535"></a><a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">00535</a> <span class="preprocessor"></span>       <span class="keyword">typedef</span> <span class="keyword">typename</span> std::map&lt;K, V, P, A&gt; <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">type</a>;
<a name="l00536"></a><a class="code" href="structOgre_1_1map.html#a1fa40220d3413b620dc9855d5cab1b96">00536</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::map&lt;K, V, P, A&gt;::iterator <a class="code" href="structOgre_1_1map.html#a1fa40220d3413b620dc9855d5cab1b96">iterator</a>;
<a name="l00537"></a><a class="code" href="structOgre_1_1map.html#a5aea2c0a4a4091b69fc65cca9f0892f9">00537</a>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::map&lt;K, V, P, A&gt;::const_iterator <a class="code" href="structOgre_1_1map.html#a5aea2c0a4a4091b69fc65cca9f0892f9">const_iterator</a>;
<a name="l00538"></a>00538 <span class="preprocessor">#else</span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::map&lt;K, V, P&gt; <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">type</a>;
<a name="l00540"></a>00540         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::map&lt;K, V, P&gt;::iterator <a class="code" href="structOgre_1_1map.html#a1fa40220d3413b620dc9855d5cab1b96">iterator</a>;
<a name="l00541"></a>00541         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::map&lt;K, V, P&gt;::const_iterator <a class="code" href="structOgre_1_1map.html#a5aea2c0a4a4091b69fc65cca9f0892f9">const_iterator</a>;
<a name="l00542"></a>00542 <span class="preprocessor">#endif</span>
<a name="l00543"></a>00543 <span class="preprocessor"></span>    }; 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> K, <span class="keyword">typename</span> V, <span class="keyword">typename</span> P = std::less&lt;K&gt;, <span class="keyword">typename</span> A = STLAllocator&lt;std::pair&lt;const K, V&gt;, GeneralAllocPolicy&gt; &gt; 
<a name="l00546"></a><a class="code" href="structOgre_1_1multimap.html">00546</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1multimap.html">multimap</a> 
<a name="l00547"></a>00547     { 
<a name="l00548"></a>00548 <span class="preprocessor">#if OGRE_CONTAINERS_USE_CUSTOM_MEMORY_ALLOCATOR</span>
<a name="l00549"></a><a class="code" href="structOgre_1_1multimap.html#abbc044dc966133fc43888a7c8cad6237">00549</a> <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::multimap&lt;K, V, P, A&gt; <a class="code" href="structOgre_1_1multimap.html#abbc044dc966133fc43888a7c8cad6237">type</a>;
<a name="l00550"></a><a class="code" href="structOgre_1_1multimap.html#af555fe7aa58ed46d909211dcda447ef9">00550</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::multimap&lt;K, V, P, A&gt;::iterator <a class="code" href="structOgre_1_1multimap.html#af555fe7aa58ed46d909211dcda447ef9">iterator</a>;
<a name="l00551"></a><a class="code" href="structOgre_1_1multimap.html#ac2259a42083733ea81521c768c21106d">00551</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::multimap&lt;K, V, P, A&gt;::const_iterator <a class="code" href="structOgre_1_1multimap.html#ac2259a42083733ea81521c768c21106d">const_iterator</a>;
<a name="l00552"></a>00552 <span class="preprocessor">#else</span>
<a name="l00553"></a>00553 <span class="preprocessor"></span>        <span class="keyword">typedef</span> <span class="keyword">typename</span> std::multimap&lt;K, V, P&gt; <a class="code" href="structOgre_1_1multimap.html#abbc044dc966133fc43888a7c8cad6237">type</a>;
<a name="l00554"></a>00554         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::multimap&lt;K, V, P&gt;::iterator <a class="code" href="structOgre_1_1multimap.html#af555fe7aa58ed46d909211dcda447ef9">iterator</a>;
<a name="l00555"></a>00555         <span class="keyword">typedef</span> <span class="keyword">typename</span> std::multimap&lt;K, V, P&gt;::const_iterator <a class="code" href="structOgre_1_1multimap.html#ac2259a42083733ea81521c768c21106d">const_iterator</a>;
<a name="l00556"></a>00556 <span class="preprocessor">#endif</span>
<a name="l00557"></a>00557 <span class="preprocessor"></span>    }; 
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 } <span class="comment">// Ogre</span>
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 <span class="preprocessor">#endif // __OgrePrerequisites_H__</span>
<a name="l00562"></a>00562 <span class="preprocessor"></span>
<a name="l00563"></a>00563 
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
